function result = updateColumnsAfterIsAnalogChannelActiveChange(originalOneColumnPerActiveAnalogChannel, ...
                                                                analogChannelIndex, ...
                                                                originalIsAnalogChannelActiveFromAnalogChannelIndex, ...
                                                                newIsSingleChannelActive)
    % originalOneColumnPerActiveAnalogChannel is nRows x nActiveChannels                                               
    if newIsSingleChannelActive ,
        newIsAnalogChannelActiveFromAnalogChannelIndex = ws.replace(originalIsAnalogChannelActiveFromAnalogChannelIndex, ...
                                                                    analogChannelIndex, ...
                                                                    true) ;
        newActiveAIChannelIndexFromAnalogChannelIndex = ...
            ws.computeActiveChannelIndexFromChannelIndex(newIsAnalogChannelActiveFromAnalogChannelIndex) ;
        newActiveAnalogChannelIndex = newActiveAIChannelIndexFromAnalogChannelIndex(analogChannelIndex) ;
        rowCount = size(originalOneColumnPerActiveAnalogChannel, 1) ;
        result = ws.insertColumn(originalOneColumnPerActiveAnalogChannel, newActiveAnalogChannelIndex, nan(rowCount,1)) ;
    else
        originalActiveAIChannelIndexFromAIChannelIndex = ...
            ws.computeActiveChannelIndexFromChannelIndex(originalIsAnalogChannelActiveFromAnalogChannelIndex) ;
        originalActiveAnalogChannelIndex = originalActiveAIChannelIndexFromAIChannelIndex(analogChannelIndex) ;
        result = ws.deleteColumns(originalOneColumnPerActiveAnalogChannel, originalActiveAnalogChannelIndex) ;        
    end
end
